#!/usr/bin/env bash

# Copyright 2020 The PipeCD Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Copyright 2017 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set -o errexit
set -o nounset
set -o pipefail

VERSION="$(git describe --tags --always --dirty --abbrev=7)"
GIT_COMMIT="$(git rev-parse HEAD)"
BUILD_DATE="$(date -u '+%Y%m%d-%H%M%S')"

cat <<EOF
STABLE_VERSION ${VERSION}
STABLE_GIT_COMMIT ${GIT_COMMIT}
STABLE_BUILD_DATE ${BUILD_DATE}
version ${VERSION}
gitCommit ${GIT_COMMIT}
buildDate ${BUILD_DATE}
EOF
